#include<iostream>
#include<algorithm>
#include<vector>
using namespace std;

const int MAX_N = 3000 + 24;
const int MAX_M = 1e5 + 24;

int n, m;
int flowers[MAX_N], L[MAX_M], R[MAX_M];
unsigned long long K[MAX_M];

void fast_io(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

void input(){
    cin >> n >> m;
    for(int i = 0; i < n; ++i){
        cin >> flowers[i];
    }
    for(int i = 0; i < m; ++i){
        cin >> L[i] >> R[i] >> K[i];
    }
}

void solve(){
    sort(flowers, flowers + n);

    for(int i = 0; i < m; ++i){
        auto l = lower_bound(flowers, flowers + n, L[i]),
             r = upper_bound(flowers, flowers + n, R[i]);
        int p = r - l;
        // if a bouqet uses Q flowers, we can make P choose Q bouqets
        if(K[i] == 1 && p > 0){
            cout << 1 << "\n";
        }else{
            cout << -1 << "\n";
        }
    }

}

int main(){
    //fast_io();
    input();
    solve();
    return 0;
}
